From: Serge Semin <fancer.lancer@gmail.com>
To: jdmason@kudzu.us, dave.jiang@intel.com, Allen.Hubbe@emc.com,
Shyam-sundar.S-k@amd.com, Xiangliang.Yu@amd.com,
logang@deltatee.com
Cc: Sergey.Semin@t-platforms.ru, linux-ntb@googlegroups.com,
linux-kernel@vger.kernel.org,
Serge Semin <fancer.lancer@gmail.com>
Subject: [PATCH 02/08] NTB: ntb_test: Add ntb_tool port tests
Date: Fri, 1 Dec 2017 00:42:54 +0300 [thread overview]
Message-ID: <20171130214300.21298-2-fancer.lancer@gmail.com> (raw)
In-Reply-To: <20171130214300.21298-1-fancer.lancer@gmail.com>
Multi-port interface is now available in ntb_tool driver. According
to the new NTB API, there might be more than two devices connected over
NTB. It means each device can have multiple freely enumerated ports.
Each port got index assigned by NTB hardware driver. This test is
performed to determine the local and peer ports as well as their indexes.
Signed-off-by: Serge Semin <fancer.lancer@gmail.com>
---
tools/testing/selftests/ntb/ntb_test.sh | 52 +++++++++++++++++++++++++++++++++
1 file changed, 52 insertions(+)
diff --git a/tools/testing/selftests/ntb/ntb_test.sh b/tools/testing/selftests/ntb/ntb_test.sh
index a8647ad891eb..541ba70ad640 100755
--- a/tools/testing/selftests/ntb/ntb_test.sh
+++ b/tools/testing/selftests/ntb/ntb_test.sh
@@ -127,6 +127,56 @@ function write_file()
fi
}
+function check_file()
+{
+ split_remote $1
+
+ if [[ "$REMOTE" != "" ]]; then
+ ssh "$REMOTE" "[[ -e ${VPATH} ]]"
+ else
+ [[ -e ${VPATH} ]]
+ fi
+}
+
+function find_pidx()
+{
+ PORT=$1
+ PPATH=$2
+
+ for ((i = 0; i < 64; i++)); do
+ PEER_DIR="$PPATH/peer$i"
+
+ check_file ${PEER_DIR} || break
+
+ PEER_PORT=$(read_file "${PEER_DIR}/port")
+ if [[ ${PORT} -eq $PEER_PORT ]]; then
+ echo $i
+ return 0
+ fi
+ done
+
+ return 1
+}
+
+function port_test()
+{
+ LOC=$1
+ REM=$2
+
+ echo "Running port tests on: $(basename $LOC) / $(basename $REM)"
+
+ LOCAL_PORT=$(read_file "$LOC/port")
+ REMOTE_PORT=$(read_file "$REM/port")
+
+ LOCAL_PIDX=$(find_pidx ${REMOTE_PORT} "$LOC")
+ REMOTE_PIDX=$(find_pidx ${LOCAL_PORT} "$REM")
+
+ echo "Local port ${LOCAL_PORT} with index ${REMOTE_PIDX} on remote host"
+ echo "Peer port ${REMOTE_PORT} with index ${LOCAL_PIDX} on local host"
+
+ echo " Passed"
+}
+
function link_test()
{
LOC=$1
@@ -327,6 +377,8 @@ function ntb_tool_tests()
_modprobe ntb_tool
+ port_test "$LOCAL_TOOL" "$REMOTE_TOOL"
+
write_file "Y" "$LOCAL_TOOL/link_event"
write_file "Y" "$REMOTE_TOOL/link_event"
--
2.12.0
next prev parent reply other threads:[~2017-11-30 21:43 UTC|newest]
Thread overview: 12+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-11-30 21:42 [PATCH 01/08] NTB: ntb_test: Safely use paths with whitespace Serge Semin
2017-11-30 21:42 ` Serge Semin [this message]
2017-11-30 22:37 ` [PATCH 02/08] NTB: ntb_test: Add ntb_tool port tests Logan Gunthorpe
2017-11-30 21:42 ` [PATCH 03/08] NTB: ntb_test: Update ntb_tool link tests Serge Semin
2017-11-30 21:42 ` [PATCH 04/08] NTB: ntb_test: Update ntb_tool DB tests Serge Semin
2017-11-30 21:42 ` [PATCH 05/08] NTB: ntb_test: Update ntb_tool Scratchpad tests Serge Semin
2017-11-30 21:42 ` [PATCH 06/08] NTB: ntb_test: Add ntb_tool Message tests Serge Semin
2017-11-30 21:42 ` [PATCH 07/08] NTB: ntb_test: Update ntb_tool MW tests Serge Semin
2017-11-30 21:43 ` [PATCH 08/08] NTB: ntb_test: Update ntb_perf tests Serge Semin
2017-11-30 22:04 ` [PATCH 01/08] NTB: ntb_test: Safely use paths with whitespace Logan Gunthorpe
2017-11-30 22:12 ` Serge Semin
2017-11-30 22:26 ` Logan Gunthorpe
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20171130214300.21298-2-fancer.lancer@gmail.com \
--to=fancer.lancer@gmail.com \
--cc=Allen.Hubbe@emc.com \
--cc=Sergey.Semin@t-platforms.ru \
--cc=Shyam-sundar.S-k@amd.com \
--cc=Xiangliang.Yu@amd.com \
--cc=dave.jiang@intel.com \
--cc=jdmason@kudzu.us \
--cc=linux-kernel@vger.kernel.org \
--cc=linux-ntb@googlegroups.com \
--cc=logang@deltatee.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox